import { Connection } from '@salesforce/core';
import { ExecuteAnonymousResponse, ApexExecuteOptions, SoapResponse, RequestData } from './types';
export declare class ExecuteService {
    readonly connection: Connection;
    constructor(connection: Connection);
    executeAnonymous(options: ApexExecuteOptions): Promise<ExecuteAnonymousResponse>;
    getApexCode(options: ApexExecuteOptions): Promise<string>;
    readApexFile(filepath: string): string;
    getUserInput(): Promise<string>;
    private buildExecRequest;
    jsonFormat(soapResponse: SoapResponse): ExecuteAnonymousResponse;
    connectionRequest(requestData: RequestData): Promise<SoapResponse>;
}
